﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

// Credit to Yan Sidorenko

namespace ConsoleApplication5
{
    class Bird: Animal
    {
        private int height;
        private int wings_length;
        //Constructor
        public Bird(string animal_name, int animal_age, bool is_attacker, int calories_per_launch, int height, int wings_length): base(animal_name, animal_age, is_attacker, calories_per_launch)
        {
            this.height = height;
            this.wings_length = wings_length;
        }
        //Get Methods
        public int GetHeight() { return this.height; }
        public int GetWingsLength() { return this.wings_length; }
        
        //Set Methods
        public void SetHeight(int height){ this.height = height; }
        public void SetWingsLength(int wings_length) { this.wings_length = wings_length; }
        
        //ToString Method
        public override string ToString()
        {
            return base.ToString() + "\nFly Height: " + this.height + "\nWings Length: " + this.wings_length;
        }

        public override int Eat() { return base.Eat()/(this.height+this.wings_length); } //return calories for 3 meals divided by the mass of the bird. O(1)

        public virtual void Sing() { Console.WriteLine("WIWYWIWYWIWY...."); } //printing the bird's sing. O(1)

        public void Dance() { Console.WriteLine("SUpppp Babyyy Wanna dance with me?!?!"); } //printing the bird's dance. O(1)


    }
}
