﻿using System;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TreeDLR;
using Unit4.CollectionsLib;

// Credit to Yan Sidorenko


namespace ConsoleApplication5
{
    class Park
    {
        private Animal[] animals = new Animal[1000];
        private int number_of_animals = 0;
        //Constructor
        public Park() { }

        public void Add(Animal animal)// adding an animal to the park. O(1)
        {
            this.animals[this.number_of_animals] = animal;
            this.number_of_animals++;
        }

        public Node<Animal> OlderAndPredator()
        // Credit to Gili Rozin
        //החזרת רשימה של כל החיות שגילן מעל 10 והן טורפות על 
        {
            int i = 0;
            while (i < this.animals.Length && !(this.animals[i].GetIsPredator() && this.animals[i].GetAge() > 10)) //מציאת חיה ראשונה שעונה על הדרישות
                i++;
            if (i < animals.Length) //יש לפחות חיה אחת שעונה על התנאים במערך
            {
                Node<Animal> ls = new Node<Animal>(animals[i]);
                Node<Animal> head = ls;
                Node<Animal> lsNext;

                while (i < this.animals.Length)
                {
                    if (this.animals[i].GetIsPredator() && this.animals[i].GetAge() > 10)
                    {
                        lsNext = new Node<Animal>(this.animals[i]);
                        ls.SetNext(lsNext);
                        ls = lsNext;
                    }
                    i++;
                }
            }

            return head;
        }
        
        public int AmountOfBirdsAndReptiles()// returns the number of birds and reptiles in the park. O(n) n = number of animals in the array.
        {
            int counter = 0;
            for (int i = 0; i<this.animals.Length;i++)
            {
                if (animals[i] is Bird)
                    counter++;
                if (animals[i] is Reptile)
                    counter++;
            }
            return counter;
        }

    }
}
